<?php
	/**
 	*    Webmoney Merchant *
 	* @copyright disc [disc@droidov.net]
 	* @version 1.0
 	*/
	class WmMerchant {
		/**
		 *  ,    
		 *
		 * @var array
		 */
		private $_wmFields = array();
		
		function __construct() {
			$this->_wmFields = array('LMI_PAYMENT_AMOUNT'=>1, // 
									 'LMI_PAYMENT_DESC'=>" ", // 
									 'LMI_PAYMENT_NO'=>1, // ID 
									 'LMI_PAYEE_PURSE'=>'Z000000000006', // 
									 'LMI_SIM_MODE'=>0,// 0:      ; 
									 );
		}
		
		/**
		 *   .        $addFields field=>value
		 *
		 * @param unknown_type $addFields
		 * @return string or bool
		 */
		public function generatePayForm($addFields=null) {
			if (!empty($this->_wmFields['LMI_PAYMENT_AMOUNT']) and !empty($this->_wmFields['LMI_PAYEE_PURSE']) ) {
				if (!empty($addFields)) {
					$fullArray = array_merge($this->_wmFields, $addFields);
				} else {
					$fullArray = $this->_wmFields;
				}
				$resultForm = '<form method="POST" action="https://merchant.webmoney.ru/lmi/payment.asp">'."\n";
				foreach ($fullArray as $name=>$value) {
					if (!empty($name)) {
						$resultForm .= '<input type="hidden" name="'.$name.'" value="'.$value.'">'."\n";
					}
				}
				$resultForm .= '<input type="submit" value="submit"></form>';
				return $resultForm;
			} else {
				return false;
			}
		}
		
		/**
		 *     .       Result URL
		 *
		 * @return bool
		 */
		public function prerequest() {
			if (isset($_POST['LMI_PREREQUEST']) == 1) {
				//    
				if ($_POST['LMI_PAYEE_PURSE'] == $this->_wmFields['LMI_PAYEE_PURSE'] and $_POST['LMI_PAYMENT_AMOUNT'] == $this->_wmFields['LMI_PAYMENT_AMOUNT']) {
					header('Content-Type: text/xml; charset=windows-1251');
					echo 'YES';
					return true;
				} else {
					return false;
				}
			} else {
				@$string = $_POST['LMI_PAYEE_PURSE'].$_POST['LMI_PAYMENT_AMOUNT'].$_POST['LMI_PAYMENT_NO'].$_POST['LMI_MODE'].$_POST['LMI_SYS_INVS_NO'].$_POST['LMI_SYS_TRANS_NO'].$_POST['LMI_SYS_TRANS_DATE'].$_POST['LMI_SECRET_KEY'].$_POST['LMI_PAYER_PURSE'].$_POST['LMI_PAYER_WM'];
				$hash = strtoupper(md5($string));
				if (isset($_POST['LMI_HASH']) == $hash) {
					/*
					  ,   
					*/
				} else {
					/*
					  ,   -    
					*/
				}
			}
		}
		
		/**
		 *       .
		 *
		 * @return bool
		 */
		public function isSuccess() {
			if (isset($_POST['LMI_PAYMENT_NO']) and isset($_POST['LMI_SYS_INVS_NO']) and isset($_POST['LMI_SYS_TRANS_NO']) and isset($_POST['LMI_SYS_TRANS_DATE'])) {
				/*
				       LMI_PAYMENT_NO,    .
				*/
			} else {
				return false;
			}
		}
		
		/**
		 *   
		 *
		 * @param float $price
		 * @return bool
		 */
		public function setPrice($price) {
			if (!empty($price)) {
				if (is_numeric($price) and $price > 0.00) {
					$this->_wmFields['LMI_PAYMENT_AMOUNT'] = $price;
					return true;
				} else {
					return false;
				}
			}
		}
		
		/**
		 *   ,  255 
		 *
		 * @param string $desc
		 * @return bool
		 */
		public function setDescription($desc) {
			if (!empty($desc)) {
				$this->_wmFields['LMI_PAYMENT_DESC'] = substr($desc,0,255);
				return true;
			} else {
				return false;
			}
		}
		
		/**
		 *    
		 *
		 * @param string $number
		 * @return bool
		 */
		public function setPurseNumber($number) {
			if (!empty($number)) {
				$this->_wmFields['LMI_PAYEE_PURSE'] = $number;
				return true;
			} else {
				return false;
			}
		}
		
		/**
		 *    
		 *
		 * @param integer $number
		 * @return bool
		 */
		public function setPaymentNumber($number) {
			if (is_integer($number)) {
				$this->_wmFields['LMI_PAYMENT_NO'] = $number;
				return true;
			} else {
				return false;
			}
		}
	}
	
?>